//+------------------------------------------------------------------+
//|                                                          lib.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#include <stderror.mqh>
#include <stdlib.mqh>

#define MAGICMA  20050610

//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
// #define MacrosHello   "Hello, world!"
// #define MacrosYear    2005

//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+
// #import "user32.dll"
//   int      SendMessageA(int hWnd,int Msg,int wParam,int lParam);

// #import "my_expert.dll"
//   int      ExpertRecalculate(int wParam,int lParam);
// #import

//+------------------------------------------------------------------+
//| EX4 imports                                                      |
//+------------------------------------------------------------------+
// #import "stdlib.ex4"
//   string ErrorDescription(int error_code);
// #import
//+------------------------------------------------------------------+



int WriteFile (string FN, string str) {
	int handle = FileOpen( FN, FILE_WRITE | FILE_READ, " " );
	FileSeek( handle, 0, SEEK_END );
	FileWrite( handle, str );
	FileClose( handle );
   return(0);
}

void sndMessage(string HeaderLetter, string BodyLetter)
{
   int RetVal;
   SendMail( HeaderLetter, BodyLetter );
   RetVal = GetLastError();
   if (RetVal!= ERR_NO_MQLERROR) Print (",   : ", ErrorDescription(RetVal));
}


double LotsOptimized(double lots) {
   int lot;
   if (AccountBalance() > 350.00) {
      return(0.1);
   }
   if (AccountBalance() > 650.00) {
      return(0.2);
   }
   if (AccountBalance() > 950.00) {
      return(0.3);
   }
   if (AccountBalance() > 1250.00) {
      return(0.4);
   }
   if (AccountBalance() > 1750.00) {
      return(0.5);
   }
  
   return(lots);
}


bool IsLinesCross (double y11, double y12, double y21, double y22) {

double maxx1,maxy1,minx1,miny1, maxx2 , maxy2, minx2, miny2;
double x11 = 1, x12 = 2, x21 = 1, x22 = 2;

double dx1, dy1, dx2, dy2, dxx, dyy, div, mul;

   if (x11 > x12) maxx1 = x11; else maxx1 = x12;
   if (y11 > y12) maxy1 = y11; else maxy1 = y12;

   if (x11 < x12) minx1 = x11; else minx1 = x12;
   if (y11 < y12) miny1 = y11; else miny1 = y12;

   if (x21 > x22) maxx2 = x21; else maxx2 = x22;
   if (y21 > y22) maxy2 = y21; else maxy2 = y22;      

   if (x21 < x22) minx2 = x21; else minx2 = x22;
   if (y21 < y22) miny2 = y21; else miny2 = y22;

   if ((minx1 > maxx2) || (maxx1 < minx2) || (miny1 > maxy2) || (maxy1 < miny2))
      return (false);  // ,      ...
 

   dx1 = x12-x11; dy1 = y12-y11; //       x  y
   dx2 = x22-x21; dy2 = y22-y21; //       x  y
   dxx = x11-x21; dyy = y11-y21;

   div = dy2*dx1-dx2*dy1;

   if (div == 0)
      return (false); //  ...
   if (div > 0) {
      mul = dx1*dyy-dy1*dxx;
      if (mul < 0 || mul > div)
         return (false); //      ...
      mul = dx2*dyy-dy2*dxx;   
      if (mul < 0 || mul > div)
         return (false); //      ...
   }
   
   mul = -(dx1*dyy-dy1*dxx);
   if (mul < 0 || mul > -div)
      return (false); //      ...
   mul = -(dx2*dyy-dy2*dxx);
   if (mul < 0 || mul > -div)
      return (false); //      ...

   return (true);
}

int TF2Val(int Constant ) {
   switch(Constant) {
      case 1:  // M1
         return(1);
      case 5:  // M5
         return(2);
      case 15:
         return(3);
      case 30:
         return(4);
      case 60:
         return(5);
      case 240:
         return(6);
      case 1440:
         return(7);
      case 10080:
         return(8);
      case 43200:
         return(9);
   }
}

//+------------------------------------------------------------------+
//| Time frame string appropriation  function                               |
//+------------------------------------------------------------------+

string TFVal2String(int Value ) {
   switch(Value) {
      case 1:  // M1
         return("PERIOD_M1");
      case 2:  // M1
         return("PERIOD_M5");
      case 3:
         return("PERIOD_M15");
      case 4:
         return("PERIOD_M30");
      case 5:
         return("PERIOD_H1");
      case 6:
         return("PERIOD_H4");
      case 7:
         return("PERIOD_D1");
      case 8:
         return("PERIOD_W1");
      case 9:
         return("PERIOD_MN1");
   	default: 
   		return("undefined " + Value);
   }
}

int Symbol2Val(string symbol) {
	if(symbol=="AUDUSD") {	return(01);

	} else if(symbol=="CHFJPY") {	return(10);

	} else if(symbol=="EURAUD") {	return(10);
	} else if(symbol=="EURCAD") {	return(11);
	} else if(symbol=="EURCHF") {	return(12);
	} else if(symbol=="EURGBP") {	return(13);
	} else if(symbol=="EURJPY") {	return(14);
	} else if(symbol=="EURUSD") {	return(15);

	} else if(symbol=="GBPCHF") {	return(20);
	} else if(symbol=="GBPJPY") {	return(21);
	} else if(symbol=="GBPUSD") { return(22);


	} else if(symbol=="USDCAD") {	return(40);
	} else if(symbol=="USDCHF") {	return(41);
	} else if(symbol=="USDJPY") {	return(42);


	} else if(symbol=="GOLD") {	return(90);
	} else {	Comment("unexpected Symbol"); return(0);
	}
}


